# -*- coding: utf-8 -*-

"""
Scalix Installer
VERSION 0.11.4.1

Copyright (C) 2008 Rene Hadler
rene.hadler@aon.at

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, re, sys

class fileobj:
    
    file = ""
    abort = False
    r_data = ""
    m_data = ""

    def __init__(self, file):
        fp = open(file, "r")
        self.r_data = fp.readlines()
        fp.seek(0)
        self.m_data = fp.readlines()
        fp.close()
        self.file = file
    
    def astrtvar(self, sstr, tapp):
        tmp = []
        for line in self.m_data:
            line = line.replace("\n", "")
            if re.match(sstr, line):
                tw = line.split("=")
                line = tw[0] + "=\"" + tw[1].replace('"', "") + tapp + "\""
            else:
                self.abort = True
                
            tmp.append(line)
            
        self.m_data = tmp
        
    def mstrtvar(self, sstr, tapp):
        tmp = []
        for line in self.m_data:
            line = line.replace("\n", "")
            if re.match(sstr, line):
                tw = line.split("=")
                line = tw[0] + "=\"" + tapp + "\""
            else:
                self.abort = True
                
            tmp.append(line)
            
        self.m_data = tmp
        
    def astrtvarwoc(self, sstr, tapp):
        tmp = []
        for line in self.m_data:
            line = line.replace("\n", "")
            if re.match(sstr, line):
                tw = line.split("=")
                line = tw[0] + "=" + tw[1].replace('"', "") + tapp
            else:
                self.abort = True
                
            tmp.append(line)
            
        self.m_data = tmp
        
    def mstrtvarwoc(self, sstr, tapp):
        tmp = []
        for line in self.m_data:
            line = line.replace("\n", "")
            if re.match(sstr, line):
                tw = line.split("=")
                line = tw[0] + "=" + tapp
            else:
                self.abort = True
                
            tmp.append(line)
            
        self.m_data = tmp
        
    def rstrtvarwoc(self, sstr, tapp):
        tmp = []
        for line in self.m_data:
            line = line.replace("\n", "")
            if re.match(sstr, line):
                tw = line.split("=")
                line = tapp
            else:
                self.abort = True
                
            tmp.append(line)
            
        self.m_data = tmp
    
    def astrtfile(self, tapp):
        self.m_data.append(tapp)
        
    def anltfile(self):
        self.m_data.append("")
        
    def write(self):
        fp = open(self.file, "w")
        for line in self.m_data:
            fp.write(line.replace("\n", "") + "\n")
        fp.close()
        
    def write_wd(self, dest):
        fp = open(dest, "w")
        for line in self.m_data:
            fp.write(line.replace("\n", "") + "\n")
        fp.close()
        
    def write_wb(self):
        fp = open(self.file + "_backup", "w")
        for line in self.r_data:
            fp.write(line.replace("\n", "") + "\n")
        fp.close()
        fp = open(self.file, "w")
        for line in self.m_data:
            fp.write(line.replace("\n", "") + "\n")
        fp.close()
        
    def print_rdata(self):
        for line in self.r_data:
            print line.replace("\n", "")
            
    def print_mdata(self):
        for line in self.m_data:
            print line.replace("\n", "")
            
class i18n:
    
    lang = ""
    wordlist = {}
    
    def __init__(self):
        l = self._cmd("echo $LANG")[0]

        if re.match("^de_.*$", l): self.lang = "german"
        else: self.lang = "english"
        
        self._precache_wordlist()
        
    def _cmd(self, cmd):
        pp = os.popen(cmd + " 2>&1")
        output = pp.readlines()
        pp.close()
        
        return output
    
    def _precache_wordlist(self):
        fp = open("lang/" + self.lang + ".lang", "r")
        for line in fp.readlines():
            if line.startswith("#"):
                continue
            tmp = line.split("=")
            try: self.wordlist[tmp[0].strip()] = tmp[1].strip()
            except: pass
        fp.close()
            
    def get(self, key):
        try: return self.wordlist[key]
        except: return "Not in translation db (yet)!"